<?php

/**
 * MultiFlexi API
 * PHP version 7.4.
 *
 * @author  OpenAPI Generator team
 *
 * @see    https://github.com/openapitools/openapi-generator
 */

/**
 * This is an example of using OAuth2 Application Flow in a specification to describe security to your API.
 * The version of the OpenAPI document: 1.1.0
 * Contact: vitezslav.dvorak@spojenet.cz
 * Generated by: https://github.com/openapitools/openapi-generator.git.
 */

declare(strict_types=1);

/**
 * This file is part of the MultiFlexi package
 *
 * https://multiflexi.eu/
 *
 * (c) Vítězslav Dvořák <http://vitexsoftware.com>
 *
 * For the full copyright and license information, please view the LICENSE
 * file that was distributed with this source code.
 */

namespace MultiFlexi\Api\App;

/**
 * RegisterMiddlewares.
 *
 * Recommendations from template creator:
 *
 * There is no way to add route related middlewares here, add global ones. Route related middlewares
 * can be applied in \MultiFlexi\Api\App\RegisterRoutes class.
 *
 * I add middlewares by full class names(\Slim\Middleware\ErrorMiddleware::class) because that way
 * Slim initiates them with options from Container. They already configured, don't need to pass any
 * options manually.
 *
 * I don't use imports(eg. use Slim\Middleware\ErrorMiddleware) here because each package unlikely
 * be used in code twice. It helps to keep that file short and make Git history cleaner.
 *
 * This class declared as final because two classes with middlewares can cause confusion. Edit
 * template of this class or use your own implementation instead(overwrite index.php to import your
 * custom class).
 */
final class RegisterMiddlewares
{
    /**
     * Adds middlewares to Slim app instance.
     *
     * @param \Slim\App $app app instance
     */
    public function __invoke(\Slim\App $app): void
    {
        // Parse json, form data and xml
        $app->addBodyParsingMiddleware();

        // Add Routing Middleware
        $app->addRoutingMiddleware();

        // Add Error Middleware
        $app->add(\Slim\Middleware\ErrorMiddleware::class);
    }
}
